/* Sistemas Integrados TECNISA
   Servios

Nome: LIMPA_ATE

Descrio:
Limpa os dados do Plano de Vo.

Criao:
26/04/01 - Raphael Freitas Pinheiro */

CREATE OR REPLACE PROCEDURE LIMPA_ATE
   (P_CDFILLISTA IN VARCHAR2,
    P_TCDFILIAL  IN VARCHAR2,
    P_IDLIMPPLAN IN VARCHAR2,
    P_NMOPERADOR IN OPERADOR.NMOPERADOR%TYPE,
    P_DSSISTEMA  IN VARCHAR2,
    P_DSLIMPEZA  IN VARCHAR2,
    P_DTPLANOVOO IN DATE DEFAULT NULL,
    P_IDLIMPO OUT   VARCHAR2) AS

    V_IDLIMPO    VARCHAR2(1);

BEGIN
   V_IDLIMPO := '0';

   IF (P_IDLIMPPLAN = 'S') THEN

      /* TABELA SERVPLANO */
      DELETE
         SERVPLANO
      WHERE
         ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
         DTHRPLAVOOPV <= P_DTPLANOVOO;

      /* TABELA OBSDELIVERY */
      DELETE
         OBSDELIVERY O
      WHERE
          EXISTS (SELECT NRDELIVERY
                  FROM DELIVERY D
                  WHERE (D.CDFILIAL   = O.CDFILIAL) AND
                        (DTHRPLAVOOPV <= P_DTPLANOVOO) AND
                        (D.NRDELIVERY = O.NRDELIVERY));

      /* TABELA DELIVERY */
      DELETE
         DELIVERY
      WHERE
         ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
         DTHRPLAVOOPV <= P_DTPLANOVOO;

      /* TABELA LOGPREVPAX */
      DELETE
         LOGPREVPAX
      WHERE
         ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
         DTHRPLAPVLP <= P_DTPLANOVOO;

      /* TABELA PREVISAOPAX */
      DELETE
         PREVISAOPAX
      WHERE
         ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
         DTHRPLAVOOPV <= P_DTPLANOVOO;

      /* TABELA PLANOVOO */
      DELETE
         PLANOVOO
      WHERE
         ((INSTR(P_CDFILLISTA, CDFILIAL) <> 0) OR P_TCDFILIAL = 'T') AND
         DTHRPLAVOOPV <= P_DTPLANOVOO;

      IF SQL%ROWCOUNT <> 0 THEN
         INSERT INTO LOGLIMPEZA
            (DTLIMPDADOS, DSSISTLIMPEZ, NMOPERLIMPEZ,
             DTFINALIMPEZ, DSLIMPEZA)
          VALUES
             (SYSDATE, P_DSSISTEMA, P_NMOPERADOR,
              P_DTPLANOVOO, P_DSLIMPEZA);

          V_IDLIMPO := '1';
      END IF;
   END IF;
   P_IDLIMPO := V_IDLIMPO;
END;
/
